//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DarkGray
#property indicator_color6  Gold
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  3
#property indicator_level1  0
#property indicator_levelcolor DarkGray

//
//
//
//
//

extern double Period1 = 32;
extern double Period2 =  5;
extern double Period3 =  1;
extern double Signal  =  5;

//
//
//
//
//

double tvi[];
double tvihuu[];
double tvihud[];
double tvihdd[];
double tvihdu[];
double signal[];
double slope[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,tvihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tvihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tvihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tvihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,tvi);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);

      IndicatorShortName("Blau tick volume indicator ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

      for(int i = limit; i >= 0; i--)
      {
         double upTicks = (Volume[i]+(Close[i]-Open[i])/Point) / 2.0;
         double dnTicks = (Volume[i] - upTicks);
         double avgUp = iEma(iEma(upTicks,Period1,i,0),Period2,i,1);
         double avgDn = iEma(iEma(dnTicks,Period1,i,2),Period2,i,3);
            if (avgUp+avgDn != 0)
                  tvi[i] = iEma(100.0*(avgUp-avgDn)/(avgUp+avgDn),Period3,i,4);
            else  tvi[i] = iEma(0                                ,Period3,i,4);
            signal[i] = iEma(tvi[i],Signal,i,4);
            tvihuu[i] = EMPTY_VALUE;
            tvihud[i] = EMPTY_VALUE;
            tvihdd[i] = EMPTY_VALUE;
            tvihdu[i] = EMPTY_VALUE;

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
               if (tvi[i] > tvi[i+1]) slope[i] =  1;
               if (tvi[i] < tvi[i+1]) slope[i] = -1;
               if (tvi[i]>0)
               if (slope[i]==1)
                     tvihuu[i] = tvi[i];
               else  tvihud[i] = tvi[i];
               if (tvi[i]<0)
               if (slope[i]==1)
                     tvihdu[i] = tvi[i];
               else  tvihdd[i] = tvi[i];
      }
      return(0);
   return(0);
         
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][6];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}